import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Layered{
  JFrame frame;
  JPanel p1, p2, p3;
  JLayeredPane jlp;
  
  public Layered(){

    frame = new JFrame("JLayeredPane Test");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    jlp = frame.getLayeredPane();

    p1 = new JPanel(new GridLayout(3, 1));
    p2 = new JPanel(new GridLayout(2, 2));
    p3 = new JPanel(new FlowLayout(FlowLayout.CENTER));

    p1.add(new JLabel("Bottom1"));
    p1.add(new JLabel("Bottom2"));
    p1.add(new JLabel("Bottom3"));

    p2.add(new JTextField("Middle 1"));
    p2.add(new JTextField("Middle 2"));
    p2.add(new JTextField("Middle 3"));
    p2.add(new JTextField("Middle 4"));

    for (int i = 1; i <= 5; ++i){
      p3.add(new JButton("Top " + i));
    }

    p1.setBorder(BorderFactory.createLineBorder(Color.red, 3));
    p1.setLocation(10, 10);
    p1.setSize(200, 200);
    p1.addMouseListener(new MouseAdapter(){

      public void mouseClicked(MouseEvent me){

        if (jlp.getLayer(p1) == 10){ //p1p3̑wւ
          jlp.setLayer(p1, 30);
          jlp.setLayer(p3, 10);
        }
        else{
          jlp.setLayer(p3, 30);      //ɖ߂
          jlp.setLayer(p1, 10);
        }
      }
    });

    p2.setBorder(BorderFactory.createLineBorder(Color.green, 3));
    p2.setLocation(40, 40);
    p2.setSize(200, 200);

    p3.setBorder(BorderFactory.createLineBorder(Color.blue, 3));
    p3.setLocation(70, 70);
    p3.setSize(200, 200);
    p3.addMouseListener(new MouseAdapter(){

      public void mouseClicked(MouseEvent me){

        if (jlp.getLayer(p3) == 30){ //p2p3̑wւ
          jlp.setLayer(p2, 30);
          jlp.setLayer(p3, 20);
        }
        else{
          jlp.setLayer(p3, 30);      //ɖ߂
          jlp.setLayer(p2, 20);
        }
      }
    });
          

    jlp.add(p1, new Integer(10)); //΂
    jlp.add(p2, new Integer(20));
    jlp.add(p3, new Integer(30)); //΂

    frame.setSize(300, 350);
    frame.setVisible(true);
  }

  public static void main(String[] args){

    new Layered();
  }
}

