import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;

public class LayoutSamples{
  JFrame frame;
  Container con;
  JTabbedPane jtp;
  JPanel flowL, flowC, flowR, grid1, grid2, border, gridbag1, gridbag2;
  JPanel bp1, bp2;
  JPanel[] panels;
  JTextArea jta;
  JTextField jtf1, jtf2;
  JButton [] buttons;

  public LayoutSamples(){

    frame = new JFrame("CAEgTv");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    con = frame.getContentPane();

    jtp = new JTabbedPane();

    buttons = new JButton[20];
    for (int i = 0; i < buttons.length; ++i){ //{^̔z
      buttons[i] = new JButton(String.valueOf(i + 1));
    }

    //BorderLayoutp̖ߑ
    jta = new JTextArea("\n\n\n\tWEST    CENTER    EAST");
    jtf1 = new JTextField("        NORTH"); 
    jtf2 = new JTextField("        SOUTH"); 

    flowL = new JPanel(new FlowLayout(FlowLayout.LEFT));
    flowC = new JPanel(new FlowLayout(FlowLayout.CENTER));
    flowR = new JPanel(new FlowLayout(FlowLayout.RIGHT));
    grid1 = new JPanel(new GridLayout(4, 5));
    grid2 = new JPanel(new GridLayout(4, 5, 10, 10)); //Mbvw
    border = new JPanel(new BorderLayout());
    gridbag1 = new JPanel(new GridBagLayout());
    gridbag2 = new JPanel(new GridBagLayout());

    for (int i = 0; i < buttons.length; ++i){
      flowL.add(buttons[i]);
    }

    bp1 = new JPanel(new GridLayout(5, 1));
    bp2 = new JPanel(new GridLayout(5, 1));

    border.add(jta, BorderLayout.CENTER);
    border.add(jtf1, BorderLayout.NORTH);
    border.add(jtf2, BorderLayout.SOUTH);
    border.add(bp1, BorderLayout.WEST);
    border.add(bp2, BorderLayout.EAST);

    //W̃^upl悹
    jtp.addTab("Flow LEFT", flowL);
    jtp.addTab("Flow CENTER", flowC);
    jtp.addTab("Flow RIGHT", flowR);
    jtp.addTab("Grid nogap", grid1);
    jtp.addTab("Grid gap", grid2);
    jtp.addTab("Border", border);
    jtp.addTab("GridBag1", gridbag1);
    jtp.addTab("GridBag2", gridbag2);

    panels = new JPanel[10];  //CxgXi̕֋X̂߂̔z
    panels[0] = flowL; panels[1] = flowC; panels[2] = flowR; panels[3] = grid1; 
    panels[4] = grid2; panels[5] = border; panels[6] = gridbag1; 
    panels[7] = gridbag2; panels[8] = bp1; panels[9] = bp2; 

    jtp.addChangeListener(new TabListener(this));

    con.add(jtp);

    frame.setSize(450, 400);
    frame.setVisible(true);
  }

  public static void main(String[] args){

    new LayoutSamples();
  }
}

/*ZNgꂽ^uɑ΂ăCAEgs*/
class TabListener implements ChangeListener{
  LayoutSamples sample;
  
  public TabListener(LayoutSamples s){

    sample = s;
  }

  public void stateChanged(ChangeEvent ce){

    JTabbedPane tp = (JTabbedPane)(ce.getSource());
    int i = tp.getSelectedIndex();
    layout(sample.panels[i], i); //ł̃wȔzg
  }

  void layout(JPanel p, int id){ //idԂ̃^uplCAEg
    JPanel w, e;

    if (id < 5){ //FlowLayout, GridLayout
      for (int i = 0; i < sample.buttons.length; ++i){
        p.add(sample.buttons[i]); //Padd邾
      }
    }
    else if (id == 5){  //BorderLayout
      w = sample.panels[8];
      e = sample.panels[9];
      for (int i = 0; i < 5; ++i){ //vPO̃{^悹
        w.add(sample.buttons[i]);
      }
      for (int i = 5; i < 10; ++i){
        e.add(sample.buttons[i]);
      }
    }
    else if (id == 6){ //GridBagLayout
      doGridBag1(p);
    }
    else{
      doGridBag2(p);
    }
  }

  /*GridBag1^up*/
  void doGridBag1(JPanel pa){
  
    JPanel bpanel = new JPanel(new GridLayout(3, 3, 5, 5));
    JPanel tpanel = new JPanel(new GridBagLayout());
    bpanel.setBorder(BorderFactory.createTitledBorder("I"));
    tpanel.setBorder(BorderFactory.createTitledBorder("p[^"));

    JTextField tf1 = new JTextField();
    JTextField tf2 = new JTextField();;
    JLabel jb1 = new JLabel("@F ");
    JLabel jb2 = new JLabel("ڕWF ");
    JTextArea ta = new JTextArea();
    JScrollPane jsc = new JScrollPane(ta, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
        JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

    for (int i = 0; i < 9; ++i){ //{^plɏ悹
      bpanel.add(sample.buttons[i]);
    }
    
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.gridx = 0; gbc.gridy = 0; gbc.gridwidth = 9; gbc.gridheight = 6;
    gbc.anchor = gbc.NORTHWEST;
    pa.add(bpanel, gbc); //{^pl

    gbc = reset();
    gbc.gridx = 0; gbc.gridy = 6; gbc.gridwidth = 9;  gbc.gridheight = 4;
    gbc.anchor = gbc.NORTHWEST; gbc.fill = gbc.HORIZONTAL;
    pa.add(tpanel, gbc); //eLXgtB[hpl

    gbc = reset();
    gbc.gridx = 9; gbc.gridy = 0; gbc.gridwidth = 9; gbc.gridheight = 12;
    gbc.anchor = gbc.NORTHEAST; gbc.fill = gbc.BOTH;
    gbc.weightx = 1.0; gbc.weighty = 1.0;
    pa.add(jsc, gbc); //eLXgGA + XN[yC

    //x + eLXgtB[htpanelɂQZbg悹
    gbc = reset();
    gbc.gridx = 0; gbc.gridy = 0; gbc.gridwidth = 3; gbc.gridheight = 2;
    gbc.anchor = gbc.WEST;
    tpanel.add(jb1, gbc);
    gbc.gridx = 3; gbc.gridy = 0; gbc.gridwidth = 6; gbc.gridheight = 2;
    gbc.anchor = gbc.WEST; gbc.fill = gbc.HORIZONTAL; gbc.weightx = 1.0;
    tpanel.add(tf1, gbc);

    gbc = reset();
    gbc.gridx = 0; gbc.gridy = 2; gbc.gridwidth = 3; gbc.gridheight = 2;
    gbc.anchor = gbc.WEST;
    tpanel.add(jb2, gbc);
    gbc.gridx = 3; gbc.gridy = 2; gbc.gridwidth = 6; gbc.gridheight = 2;
    gbc.anchor = gbc.WEST; gbc.fill = gbc.HORIZONTAL; gbc.weightx = 1.0;
    tpanel.add(tf2, gbc);
  }

  /*ǎ҂̎p -- GridBag2^ugp*/
  void doGridBag2(JPanel pa){

  }

  /* GridBagConstraintsZbg */
  GridBagConstraints reset(){

    return new GridBagConstraints();
  }
}
