import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class MiniApplication{
  JFrame mainFrame;
  JMenuBar menuBar;
  JToolBar toolBar;
  JPopupMenu popupMenu;
  
  public MiniApplication(){

    mainFrame = new JFrame("Mini Application");
    mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    menuBar = new JMenuBar();
    setupMenus(menuBar);

    toolBar = new JToolBar();
    setupToolbar(toolBar);

    popupMenu = new JPopupMenu();
    setupPopup(popupMenu);

    Container con = mainFrame.getContentPane();
    con.addMouseListener(new PopupController(popupMenu)); //|bvAbvj[p

    mainFrame.setJMenuBar(menuBar);
    con.add(toolBar, BorderLayout.NORTH);

    mainFrame.setSize(600, 500);
    mainFrame.setVisible(true);
  }

  /* j[o[Ƀj[ */
  void setupMenus(JMenuBar mbar){
    JMenu file, edit, disp, conf, run, help;

    mbar.setBorder(new BevelBorder(BevelBorder.RAISED));

    file = new JMenu("(F)t@C");
    edit = new JMenu("(E)  W");
    disp = new JMenu("(D)\  ");
    conf = new JMenu("(C)  ");
    run = new JMenu("(R) s");
    help = new JMenu("(H)wv");

    setupFileMenuItems(file); //{͑SZbgAbv

    mbar.add(file);
    mbar.add(edit);
    mbar.add(disp);
    mbar.add(conf);
    mbar.add(run);
    mbar.add(help);

    menuDecoration(mbar);
  }

  /* t@Cj[ */
  void setupFileMenuItems(JMenu mn){
    JMenu sm, tm;

    mn.add(new JMenuItem("VK"));
    mn.add(new JMenuItem("J"));
    mn.addSeparator();
    mn.add(sm = new JMenu("ۑ"));
    mn.add(new JMenuItem("ʖŕۑ"));
    mn.addSeparator();
    mn.add(new JMenuItem("I"));

    sm.add(new JMenuItem("fBNg"));
    sm.add(new JMenuItem("ႤfBNg"));
    sm.add(tm = new JMenu("ق̃}V"));

    tm.add(new JMenuItem("Ђ낵"));
    tm.add(new JMenuItem("䂤"));
    tm.add(new JMenuItem("Ȃ"));
    tm.add(new JMenuItem("W"));
    tm.add(new JMenuItem("낤"));
    tm.add(new JMenuItem("Ai"));
  }
  
  /* j[̂ */
  void menuDecoration(JMenuBar mbar){
    int[] nms 
      = {KeyEvent.VK_F, KeyEvent.VK_E, KeyEvent.VK_D, KeyEvent.VK_C, 
         KeyEvent.VK_R, KeyEvent.VK_H}; //V[gJbgL[

    for (int i = 0; i < mbar.getMenuCount(); ++i){
      JMenu m = mbar.getMenu(i);
      m.setIcon(new ImageIcon("z.png")); //j[̉̃ACR
      m.setMnemonic(nms[i]);           //V[gJbgL[ݒ肵
      m.setDisplayedMnemonicIndex(1);  //̉ʏ̕\w肷
    }
  }

  /* c[o[ɃACR{^ׂ */
  void setupToolbar(JToolBar tbar){
    JButton a, b, c, d, e, f, g, h;

    a = new JButton(new ImageIcon("a.png"));
    b = new JButton(new ImageIcon("b.png"));
    c = new JButton(new ImageIcon("c.png"));
    d = new JButton(new ImageIcon("d.png"));
    e = new JButton(new ImageIcon("e.png"));
    f = new JButton(new ImageIcon("f.png"));
    g = new JButton(new ImageIcon("g.png"));
    h = new JButton(new ImageIcon("h.png"));

    e.setToolTipText("<html>̕<p>k</html>"); //{͑S
    g.setToolTipText("<html>̕<p>j󂷂</html>"); //

    tbar.add(a);
    tbar.add(b);
    tbar.add(c);
    tbar.add(d);
    tbar.add(e);
    tbar.add(f);
    tbar.addSeparator();
    tbar.add(g);
    tbar.add(h);

  }

  /* |bvAbvj[ */
  void setupPopup(JPopupMenu pmenu){
    JMenuItem add, move, remove, resize, config, help;

    add = new JMenuItem("R|[lg");
    move = new JMenuItem("R|[lgړ");
    remove = new JMenuItem("R|[lg폜");
    resize = new JMenuItem("R|[lg̃TCYς");
    config = new JMenuItem("EBhE̍\ς");
    help = new JMenuItem("wv");

    pmenu.add(add);
    pmenu.add(move);
    pmenu.add(remove);
    pmenu.add(resize);
    pmenu.add(config);
    pmenu.addSeparator();
    pmenu.add(help);
  }

  public static void main(String[] args){

    new MiniApplication();
  }
}

/**
 * |bvAbvj[op̃}EXXi
 */
class PopupController extends MouseAdapter{
  JPopupMenu pop;

  public PopupController(JPopupMenu p){

    pop = p;
  }


  public void mousePressed(MouseEvent me){

    showPopup(me, pop);
  }

  public void mouseReleased(MouseEvent me){

    showPopup(me, pop);
  }

  void showPopup(MouseEvent e, JPopupMenu pm){

    if (e.isPopupTrigger()){
      pm.show(e.getComponent(), e.getX(), e.getY());
    }
  }
}
