import java.awt.*;
import javax.swing.*;
import java.awt.image.BufferedImage;

public class Plotting extends JPanel{
  Point prevp, newp;
  Sensor sensor;
  int xMax, yMax, yCenter;
  BufferedImage bi;
  Graphics G;

  public Plotting(Point startp){

    prevp = newp = startp;
    xMax = 750;
    yMax = 120;
    yCenter = 125;
    sensor = new Sensor();
  }

  public void doPlot(){

    while (newp.x < xMax){

      double data = sensor.readData();
      int y = yCenter - (int)((double)yMax * data);
      int x = prevp.x + 1;
      newp = new Point(x, y);
      repaint(); //̂Ssŕ`pp[^ZbgA`NGXg
      try{
        Thread.sleep(60);
      }
      catch (InterruptedException ie){
        ie.printStackTrace();
      }
      prevp = newp;
    }
  }
    
  
  public void paintComponent(Graphics g){

    if (bi == null){ // BufferdImagepӂ
      bi = new BufferedImage(getWidth(), getHeight(), BufferedImage.TYPE_INT_RGB);
      G = bi.createGraphics();
      G.setColor(Color.yellow); //wiF
      G.fillRect(0, 0, getWidth(), getHeight());
    }

    super.paintComponent(g);

    G.setColor(Color.black); // BufferedImageɕ`悵
    G.drawLine(prevp.x, prevp.y, newp.x, newp.y);
    g.drawImage(bi,0,0,null); //ʂɕ`悷
  }

  public static void main(String[] args){
    Plotting plt;

    JFrame frame = new JFrame("Plotting Sample");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    frame.getContentPane().add(plt = new Plotting(new Point(0, 125)));

    frame.setSize(750, 280);
    frame.setVisible(true);

    plt.doPlot();
  }
}

/* ZT[̕܂ */
class Sensor{
  double angle;

  public Sensor(){

    angle = 0.0;
  }

  public double readData(){
    double retval;

    retval = Math.sin(Math.toRadians(angle));
    angle += 1.0;
    if (angle >= 360){
      angle = 0.0;
    }
    return retval; //px̐lԂ
  }
}
